Imports Telerik.Web.UI

Partial Class _Default
    Inherits System.Web.UI.Page
    Dim itemIndex As String = "0"
    Private Sub CollapseAllButOne()
        For Each gridItem As GridItem In RadGrid1.MasterTableView.Controls(0).Controls
            If TypeOf (gridItem) Is GridGroupHeaderItem Then
                Dim groupHeaderItem As GridGroupHeaderItem = gridItem
                If groupHeaderItem.GroupIndex = itemIndex Then
                    groupHeaderItem.Expanded = True
                Else
                    groupHeaderItem.Expanded = False
                End If
            End If
        Next

    End Sub

    Private Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Load
        If Not IsPostBack Then
            Me.RadGrid1.Rebind() 
            Me.CollapseAllButOne()
        End If
    End Sub


    Private Sub RadGrid1_ItemCommand(ByVal sender As Object, ByVal e As Telerik.Web.UI.GridCommandEventArgs) Handles RadGrid1.ItemCommand
        If e.CommandName = RadGrid.ExpandCollapseCommandName Then
            Dim item As GridGroupHeaderItem = e.Item
            itemIndex = item.GroupIndex
        End If
        If e.CommandName = RadGrid.SortCommandName Or e.CommandName = RadGrid.PageCommandName Or e.CommandName = RadGrid.ExpandCollapseCommandName Then 'add more commands if necessary
            e.ExecuteCommand(e.Item)
            e.Canceled = True
        End If
    End Sub


    Protected Sub RadGrid1_PreRender(ByVal sender As Object, ByVal e As System.EventArgs) Handles RadGrid1.PreRender
        Me.CollapseAllButOne()
    End Sub
End Class
